#ifndef LIBREGEXIS024_TRACKING_FA_NODES_H
#define LIBREGEXIS024_TRACKING_FA_NODES_H

#include <libregexis024vm/vm_opcodes.h>
#include <libregexis024fa/finite_automaton.h>
#include <string>

bool isImmMovOpcode(regex024_opcode inst);
bool isCurPosMovOpcode(regex024_opcode inst);
bool isColarrOpcode(regex024_opcode inst);
bool isSelarrOpcode(regex024_opcode inst);

bool isTrackingFaNode(const FA_Node* n);

struct TrackingOperationInFa {
    regex024_opcode opcode;
    regex_tai_t key;
    /* Not needed for halfinvariant operations */
    uint64_t immValue;

    TrackingOperationInFa(regex024_opcode opcode, regex_tai_t key, uint64_t imm_value);

    TrackingOperationInFa(regex024_opcode opcode, regex_tai_t key);

    std::string toString() const;
};

FA_NodePathPart* convert_to_node(const TrackingOperationInFa& op, FA_Container& fa);


#endif
