#ifndef LIBREGEXIS024_LIBREGEXIS024VM_H
#define LIBREGEXIS024_LIBREGEXIS024VM_H

/* This thing is bloated. And slow (Because I designed it imperfectly and because it is bloated).
 * I could have halven the amount of bloat, but that would require me writing code in headers.
 * I am gonna use it for KM, even more bloated project. So I thought that this design is on the spot.
 * C++ is such a funny language. Code is divided into .cpp and .h files. But it only makes problems.
 * All of my work on this C++ project was not serious from the beginning. It's all funny stuff. */

/* Also, please, consider using libregexis024vm/libregexis024vm_interface.h
 * Naming in this project is super inconsistent. I don't want it to trash your namespace */

#include <libregexis024vm/vm_errno.h>
#include <libregexis024vm/utils.h>
#include <libregexis024vm/vm_opcodes_types.h>
#include <stdlib.h>
#include <stdint.h>

struct REGEX_IS024_Stack{
    regex_sslot_id_t* slots = NULL;
    regex_sslot_id_t sz = 0;

    regex_sslot_id_t pop();
    void append(regex_sslot_id_t x);
    bool empty() const;
    bool non_empty() const;

    REGEX_IS024_Stack(const REGEX_IS024_Stack&) = delete;
    REGEX_IS024_Stack& operator=(const REGEX_IS024_Stack&) = delete;
    REGEX_IS024_Stack() = default;

    ~REGEX_IS024_Stack();
};

struct REGEX024_CollectionArrayNode{
    /* Key is small for historical reasons I do not rememeber. Who cares anyway */
    regex_tai_t key;
    uint64_t value;
    /* NULL at the beginning */
    REGEX024_CollectionArrayNode* prev;
    /* Reference counting */
    uint64_t refs = 0;
};

struct REGEX_IS024_Thread{
    /* First byte field is used only when thread is located in slot */
    uint8_t slot_occupation_status = 0;
    regex_near_ptr_t IP = 0;
    REGEX024_CollectionArrayNode* CAHptr = NULL;
    /* Pointer to the seletion array. SA's are reference counted. Because of that every SA
     * is elongated by one meta element in the beginning - reference counter. So the actual elements
     * are enumerated starting from one. */
    uint64_t* SAptr = NULL;

    void delete_thread() noexcept;
    void debug_print(const char* place);
};

struct REGEX_IS024_CONTEXT{
    REGEX_IS024_CONTEXT(size_t programSize, const uint8_t *data, uint64_t caTreeLimit, regex_tai_t saLenLimit,
                        regex_sslot_id_t readSsLimit, regex_sslot_id_t forkSsLimit, uint64_t timeTickLimit);

    regex024_error_code feedSOF();
    /* You can safely pile up calls to this command, nothing bad will happen */
    regex024_error_code startThread();
    regex024_error_code extendedFeedCharacter(uint64_t input);
    regex024_error_code feedCharacter(uint64_t INP, uint64_t corresponding_byte_amount);


    ~REGEX_IS024_CONTEXT();

    /* Program size larger than 2^62 is forbidden */
    size_t program_size = 0;
    const uint8_t* prg = NULL;

    /* Max allowed index of CA is 2^16 - 1
     * Max allowed index of SA is 2^16 - 1. VM can be configured to allow even less */
    /* CA = Collecton array. */
    uint64_t CA_TREE_LIMIT;
    /* SA = Selection array */
    regex_tai_t SA_LEN_LIMIT;
    regex_sslot_id_t READ_SS_LIMIT;
    regex_sslot_id_t FORK_SS_LIMIT;

    /* If time_tick_limit is non-zero, regex virtual machine will stop with error
     * after this many ticks. This parameter set's the timeout.*/
    uint64_t time_tick_limit;

    /* This context is used only for one FA match session. This field measures each tick
     * timer <= time_tick_limit */
    uint64_t timer = 0;
    /* CAN_total <= CA_TREE_LIMIT */
    uint64_t CAN_total = 0;

    /* Program selects it */
    regex_tai_t selection_array_len = 0;
    regex_sslot_id_t read_slots_number = 0;
    regex_sslot_id_t fork_slots_number = 0;

    bool have_sift_function = false;
    regex_near_ptr_t sift_function;

    bool allows_multistart = false;
    uint8_t fed_input_extends_left = 0, fed_input_extends_right = 0;
    regex_sslot_id_t portion_of_second_read_halt_ns = 0, portion_of_FIRST_read_halt_ns = 0;

    bool initialized = false;
    regex_near_ptr_t unnatural_started_thread_IP = 1337;
    regex024_error_code error = regex024_error_codes::stable;

    REGEX_IS024_Thread* READ_halted_slots;
    REGEX_IS024_Stack READ_halted_stack_old;
    REGEX_IS024_Stack READ_halted_stack_new_first;
    REGEX_IS024_Stack READ_halted_stack_new_second;
    REGEX_IS024_Thread* FORK_halted_slots;
    REGEX_IS024_Stack FORK_halted_stack;

    REGEX_IS024_Thread active_thread;

    /* Environment for sifting stuff */
    REGEX_IS024_Thread* sifting_with = NULL;
    /* specifies the type of operation vm should do after shift (there are only two distinct options) */
    uint8_t who_started_sift;
    /* Sifting process uses IP field of active thread. Other data of thread is not modified or used during collision
     * procudure. Old IP is stored there, if needed */
    regex_near_ptr_t child_ret_IP;
    regex_near_ptr_t intruder_IP;
    /* RAX corresponds to intruder. Its data is stored in active thread field*/
    uint64_t RAX;
    /* RBX corresponds to homesteader. Its data is accessible by `REGEX_IS024_Thread* sifting_with` pointer*/
    uint64_t RBX;

    /* Will be unoccupied if no threads matched. After each feed of character this field will be wiped
     * User should take care of intermediate success himself */
    REGEX_IS024_Thread matched_thread;

    uint64_t INP = 0;
    uint64_t passed_chars = 0;
    uint64_t passed_bytes = 0;

    void try_to_continue_scheduled();

    bool check_inboundness(int region);

    uint8_t extract_b();
    uint16_t extract_w();
    uint32_t extract_dw();
    uint64_t extract_qw();

    uint8_t extract_instruction();
    regex_sslot_id_t extract_sslot_id();
    regex_near_ptr_t extract_near_pointer();
    regex_tai_t extract_track_array_index();

    void debug_print(const char* place);
};

#endif //LIBREGEXIS024_LIBREGEXIS024VM_H
