#include <libregexis024vm/libregexis024vm.h>
#include <libregexis024vm/vm_opcodes.h>

bool REGEX_IS024_CONTEXT::check_inboundness(int region){
    return vmprog_check_inboundness(program_size, active_thread.IP, region);
}

uint8_t REGEX_IS024_CONTEXT::extract_b() {
    return vmprog_extract_b(&active_thread.IP, prg);
}

uint16_t REGEX_IS024_CONTEXT::extract_w() {
    return vmprog_extract_w(&active_thread.IP, prg);
}

uint32_t REGEX_IS024_CONTEXT::extract_dw() {
    return vmprog_extract_dw(&active_thread.IP, prg);
}

uint64_t REGEX_IS024_CONTEXT::extract_qw() {
    return vmprog_extract_qw(&active_thread.IP, prg);
}

uint8_t REGEX_IS024_CONTEXT::extract_instruction() {
    return extract_b();
}

regex_sslot_id_t REGEX_IS024_CONTEXT::extract_sslot_id() {
    return extract_dw();
}

regex_near_ptr_t REGEX_IS024_CONTEXT::extract_near_pointer() {
    return extract_qw();
}

regex_tai_t REGEX_IS024_CONTEXT::extract_track_array_index() {
    return extract_w();
}
