#ifndef LIBREGEXIS024_UTILS_H
#define LIBREGEXIS024_UTILS_H

#include <stdint.h>
#include <stdlib.h>

void exitf(const char* fmt, ...);

/* 1, 2, 3, 4 on success; -1 on error */
int utf8_retrieve_size(uint8_t firstByte);

/* sz is a positive value returned by utf8_retrieve_size. Returns negative on error */
int32_t utf8_retrieve_character(int sz, size_t pos, const uint8_t* string);

/* cp is negative on error. adj is the size of letter in bytes. Can be used to adjust pos.
 * All safety checks will be performed */
void utf8_string_iterat(int32_t& cp, size_t& adj, size_t pos, const uint8_t* string, size_t string_size);

bool is_string_in_stringset(const char* strSample, const char* strSet[]);

#endif //LIBREGEXIS024_UTILS_H
